package xAspectsEditor.cd;
import edu.neu.ccs.demeter.*;
public class EqualVisitor extends UniversalVisitor {
  protected boolean is_equal =  true ;
  public boolean get_is_equal() { return is_equal; }
  public void set_is_equal(boolean new_is_equal) { is_equal = new_is_equal; }
  public EqualVisitor() { super(); }
  public EqualVisitor(boolean is_equal) {
    super();
    set_is_equal(is_equal);
  }

    private java.util.Stack history = new java.util.Stack();
    public EqualVisitor(Object obj) {
      history.push(obj);
    }
  
  public void before(Main host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_classDict(XAspect source, ClassDict dest) {
    if (is_equal) {
      XAspect obj = (XAspect) history.peek();
      Object temp1 = obj.get_classDict();
      if(temp1==null) { is_equal = false; return; }
      history.push(temp1);
    }
  }
  public void after_classDict(XAspect source, ClassDict dest) {
    if (is_equal) history.pop();
  }
  public void before_traversals(XAspect source, TraversalDict dest) {
    if (is_equal) {
      XAspect obj = (XAspect) history.peek();
      Object temp2 = obj.get_traversals();
      if(temp2==null) { is_equal = false; return; }
      history.push(temp2);
    }
  }
  public void after_traversals(XAspect source, TraversalDict dest) {
    if (is_equal) history.pop();
  }
  public void before(XAspect host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_name(ClassDict source, ClassName dest) {
    if (is_equal) {
      ClassDict obj = (ClassDict) history.peek();
      Object temp3 = obj.get_name();
      if(temp3==null) { is_equal = false; return; }
      history.push(temp3);
    }
  }
  public void after_name(ClassDict source, ClassName dest) {
    if (is_equal) history.pop();
  }
  public void before(ClassDict host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp4 = host.get_classdef();
    Object temp5 = ((ClassDict) obj).get_classdef();
    if(temp4 == null && temp5 == null) {}
    else if(temp4 == null ||
            temp5 == null ||
            !temp4.equals(temp5)) { is_equal = false; return; }
  }
  public void before_name(TraversalDict source, ClassName dest) {
    if (is_equal) {
      TraversalDict obj = (TraversalDict) history.peek();
      Object temp6 = obj.get_name();
      if(temp6==null) { is_equal = false; return; }
      history.push(temp6);
    }
  }
  public void after_name(TraversalDict source, ClassName dest) {
    if (is_equal) history.pop();
  }
  public void before_contextNode(TraversalDict source, ContextNode dest) {
    if (is_equal) {
      TraversalDict obj = (TraversalDict) history.peek();
      Object temp7 = obj.get_contextNode();
      if(temp7==null) { is_equal = false; return; }
      history.push(temp7);
    }
  }
  public void after_contextNode(TraversalDict source, ContextNode dest) {
    if (is_equal) history.pop();
  }
  public void before_traversals(TraversalDict source, TraversalRef_NList dest) {
    if (is_equal) {
      TraversalDict obj = (TraversalDict) history.peek();
      Object temp8 = obj.get_traversals();
      if(temp8==null) { is_equal = false; return; }
      history.push(temp8);
    }
  }
  public void after_traversals(TraversalDict source, TraversalRef_NList dest) {
    if (is_equal) history.pop();
  }
  public void before(TraversalDict host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_node(ContextNode source, ClassName dest) {
    if (is_equal) {
      ContextNode obj = (ContextNode) history.peek();
      Object temp9 = obj.get_node();
      if(temp9==null) { is_equal = false; return; }
      history.push(temp9);
    }
  }
  public void after_node(ContextNode source, ClassName dest) {
    if (is_equal) history.pop();
  }
  public void before(ContextNode host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_traversal(TraversalRef source, Traversal dest) {
    if (is_equal) {
      TraversalRef obj = (TraversalRef) history.peek();
      Object temp10 = obj.get_traversal();
      if(temp10==null) { is_equal = false; return; }
      history.push(temp10);
    }
  }
  public void after_traversal(TraversalRef source, Traversal dest) {
    if (is_equal) history.pop();
  }
  public void before(TraversalRef host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(Traversal host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_name(Strategy source, TraversalName dest) {
    if (is_equal) {
      Strategy obj = (Strategy) history.peek();
      Object temp11 = obj.get_name();
      if(temp11==null) { is_equal = false; return; }
      history.push(temp11);
    }
  }
  public void after_name(Strategy source, TraversalName dest) {
    if (is_equal) history.pop();
  }
  public void before_stratexpression(Strategy source, StratExpression dest) {
    if (is_equal) {
      Strategy obj = (Strategy) history.peek();
      Object temp12 = obj.get_stratexpression();
      if(temp12==null) { is_equal = false; return; }
      history.push(temp12);
    }
  }
  public void after_stratexpression(Strategy source, StratExpression dest) {
    if (is_equal) history.pop();
  }
  public void before(Strategy host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(StratExpression host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp13 = host.get_stratexp();
    Object temp14 = ((StratExpression) obj).get_stratexp();
    if(temp13 == null && temp14 == null) {}
    else if(temp13 == null ||
            temp14 == null ||
            !temp13.equals(temp14)) { is_equal = false; return; }
  }
  public void before_name(XPath source, TraversalName dest) {
    if (is_equal) {
      XPath obj = (XPath) history.peek();
      Object temp15 = obj.get_name();
      if(temp15==null) { is_equal = false; return; }
      history.push(temp15);
    }
  }
  public void after_name(XPath source, TraversalName dest) {
    if (is_equal) history.pop();
  }
  public void before_xpath(XPath source, XPathExpression dest) {
    if (is_equal) {
      XPath obj = (XPath) history.peek();
      Object temp16 = obj.get_xpath();
      if(temp16==null) { is_equal = false; return; }
      history.push(temp16);
    }
  }
  public void after_xpath(XPath source, XPathExpression dest) {
    if (is_equal) history.pop();
  }
  public void before(XPath host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(XPathExpression host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp17 = host.get_xpathexp();
    Object temp18 = ((XPathExpression) obj).get_xpathexp();
    if(temp17 == null && temp18 == null) {}
    else if(temp17 == null ||
            temp18 == null ||
            !temp17.equals(temp18)) { is_equal = false; return; }
  }
  public void before_xpathexp(XPathDef source, XPathExp dest) {
    if (is_equal) {
      XPathDef obj = (XPathDef) history.peek();
      Object temp19 = obj.get_xpathexp();
      if(temp19==null) { is_equal = false; return; }
      history.push(temp19);
    }
  }
  public void after_xpathexp(XPathDef source, XPathExp dest) {
    if (is_equal) history.pop();
  }
  public void before(XPathDef host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(XPathExp host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_pathDir(CompactXPath source, PathDir dest) {
    if (is_equal) {
      CompactXPath obj = (CompactXPath) history.peek();
      Object temp20 = obj.get_pathDir();
      if(temp20==null) { is_equal = false; return; }
      history.push(temp20);
    }
  }
  public void after_pathDir(CompactXPath source, PathDir dest) {
    if (is_equal) history.pop();
  }
  public void before_target(CompactXPath source, ClassName dest) {
    if (is_equal) {
      CompactXPath obj = (CompactXPath) history.peek();
      Object temp21 = obj.get_target();
      if(temp21==null) { is_equal = false; return; }
      history.push(temp21);
    }
  }
  public void after_target(CompactXPath source, ClassName dest) {
    if (is_equal) history.pop();
  }
  public void before_next(CompactXPath source, CompactXPath dest) {
    if (is_equal) {
      CompactXPath obj = (CompactXPath) history.peek();
      Object temp22 = obj.get_next();
      if(temp22==null) { is_equal = false; return; }
      history.push(temp22);
    }
  }
  public void after_next(CompactXPath source, CompactXPath dest) {
    if (is_equal) history.pop();
  }
  public void before(CompactXPath host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(PathDir host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(Absolute host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(Relative host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_op(VerboseXPath source, Op dest) {
    if (is_equal) {
      VerboseXPath obj = (VerboseXPath) history.peek();
      Object temp23 = obj.get_op();
      if(temp23==null) { is_equal = false; return; }
      history.push(temp23);
    }
  }
  public void after_op(VerboseXPath source, Op dest) {
    if (is_equal) history.pop();
  }
  public void before_arg1(VerboseXPath source, XPathRef dest) {
    if (is_equal) {
      VerboseXPath obj = (VerboseXPath) history.peek();
      Object temp24 = obj.get_arg1();
      if(temp24==null) { is_equal = false; return; }
      history.push(temp24);
    }
  }
  public void after_arg1(VerboseXPath source, XPathRef dest) {
    if (is_equal) history.pop();
  }
  public void before_arg2(VerboseXPath source, XPathRef dest) {
    if (is_equal) {
      VerboseXPath obj = (VerboseXPath) history.peek();
      Object temp25 = obj.get_arg2();
      if(temp25==null) { is_equal = false; return; }
      history.push(temp25);
    }
  }
  public void after_arg2(VerboseXPath source, XPathRef dest) {
    if (is_equal) history.pop();
  }
  public void before(VerboseXPath host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(Op host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(Union host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(Except host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(Intersect host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(XPathRef host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(SimpleXPathRef host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_compactxpath(CXPathExp source, CompactXPath dest) {
    if (is_equal) {
      CXPathExp obj = (CXPathExp) history.peek();
      Object temp26 = obj.get_compactxpath();
      if(temp26==null) { is_equal = false; return; }
      history.push(temp26);
    }
  }
  public void after_compactxpath(CXPathExp source, CompactXPath dest) {
    if (is_equal) history.pop();
  }
  public void before(CXPathExp host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_name(Variable source, ClassName dest) {
    if (is_equal) {
      Variable obj = (Variable) history.peek();
      Object temp27 = obj.get_name();
      if(temp27==null) { is_equal = false; return; }
      history.push(temp27);
    }
  }
  public void after_name(Variable source, ClassName dest) {
    if (is_equal) history.pop();
  }
  public void before(Variable host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_verbosexpath(ComplexXPathRef source, VerboseXPath dest) {
    if (is_equal) {
      ComplexXPathRef obj = (ComplexXPathRef) history.peek();
      Object temp28 = obj.get_verbosexpath();
      if(temp28==null) { is_equal = false; return; }
      history.push(temp28);
    }
  }
  public void after_verbosexpath(ComplexXPathRef source, VerboseXPath dest) {
    if (is_equal) history.pop();
  }
  public void before(ComplexXPathRef host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before(TraversalName host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp29 = host.get_name();
    Object temp30 = ((TraversalName) obj).get_name();
    if(temp29 == null && temp30 == null) {}
    else if(temp29 == null ||
            temp30 == null ||
            !temp29.equals(temp30)) { is_equal = false; return; }
  }
  public void before(ClassName host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp31 = host.get_name();
    Object temp32 = ((ClassName) obj).get_name();
    if(temp31 == null && temp32 == null) {}
    else if(temp31 == null ||
            temp32 == null ||
            !temp31.equals(temp32)) { is_equal = false; return; }
  }
  public void before(PrintVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((PrintVisitor) obj).get_indent();
    is_equal = is_equal && host.get_needSpace() == ((PrintVisitor) obj).get_needSpace();
  }
  public void before(CopyVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    Object temp33 = host.get_copy();
    Object temp34 = ((CopyVisitor) obj).get_copy();
    if(temp33 == null && temp34 == null) {}
    else if(temp33 == null ||
            temp34 == null ||
            !temp33.equals(temp34)) { is_equal = false; return; }
  }
  public void before(SubgraphVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_is_equal() == ((SubgraphVisitor) obj).get_is_equal();
  }
  public void before(EqualVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_is_equal() == ((EqualVisitor) obj).get_is_equal();
  }
  public void before(DisplayVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((DisplayVisitor) obj).get_indent();
  }
  public void before(TraceVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
    is_equal = is_equal && host.get_indent() == ((TraceVisitor) obj).get_indent();
  }
  public void before(UniversalVisitor host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_first(TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    if (is_equal) {
      TraversalRef_NList obj = (TraversalRef_NList) history.peek();
      Object temp35 = obj.get_first();
      if(temp35==null) { is_equal = false; return; }
      history.push(temp35);
    }
  }
  public void after_first(TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    if (is_equal) history.pop();
  }
  public void before(TraversalRef_NList host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  public void before_it(Nonempty_TraversalRef_NList source, TraversalRef dest) {
    if (is_equal) {
      Nonempty_TraversalRef_NList obj = (Nonempty_TraversalRef_NList) history.peek();
      Object temp36 = obj.get_it();
      if(temp36==null) { is_equal = false; return; }
      history.push(temp36);
    }
  }
  public void after_it(Nonempty_TraversalRef_NList source, TraversalRef dest) {
    if (is_equal) history.pop();
  }
  public void before_next(Nonempty_TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    if (is_equal) {
      Nonempty_TraversalRef_NList obj = (Nonempty_TraversalRef_NList) history.peek();
      Object temp37 = obj.get_next();
      if(temp37==null) { is_equal = false; return; }
      history.push(temp37);
    }
  }
  public void after_next(Nonempty_TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    if (is_equal) history.pop();
  }
  public void before(Nonempty_TraversalRef_NList host) {
    Object obj = history.peek();
    is_equal = is_equal && obj.getClass().equals(host.getClass());
    if(!is_equal) return;
  }
  boolean get_return_val() { return is_equal ; }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
