package xAspectsEditor.cd;
import edu.neu.ccs.demeter.*;
public class CopyVisitor extends UniversalVisitor {
  public CopyVisitor() {
    super();
  }

    private java.util.Stack history = new java.util.Stack();
    public CopyVisitor(Class firstClass) {
      try {
        history.push(firstClass.newInstance());
      } catch(Exception e) {
        e.printStackTrace();
      }
    }
  
  public Object get_copy() { return history.peek(); }
  Object get_return_val() { return get_copy() ; }
  public void before_classDict(XAspect source, ClassDict dest) {
    XAspect it = (XAspect) history.peek();
    ClassDict p = new ClassDict();
    it.set_classDict(p);
    history.push(p);
  }
  public void after_classDict(XAspect source, ClassDict dest) {
    history.pop();
  }
  public void before_traversals(XAspect source, TraversalDict dest) {
    XAspect it = (XAspect) history.peek();
    TraversalDict p = new TraversalDict();
    it.set_traversals(p);
    history.push(p);
  }
  public void after_traversals(XAspect source, TraversalDict dest) {
    history.pop();
  }
  public void before_name(ClassDict source, ClassName dest) {
    ClassDict it = (ClassDict) history.peek();
    ClassName p = new ClassName();
    it.set_name(p);
    history.push(p);
  }
  public void after_name(ClassDict source, ClassName dest) {
    history.pop();
  }
  public void before_classdef(ClassDict source, Text dest) {
    ClassDict it = (ClassDict) history.peek();
    it.set_classdef(dest);
  }
  public void before_name(TraversalDict source, ClassName dest) {
    TraversalDict it = (TraversalDict) history.peek();
    ClassName p = new ClassName();
    it.set_name(p);
    history.push(p);
  }
  public void after_name(TraversalDict source, ClassName dest) {
    history.pop();
  }
  public void before_contextNode(TraversalDict source, ContextNode dest) {
    TraversalDict it = (TraversalDict) history.peek();
    ContextNode p = new ContextNode();
    it.set_contextNode(p);
    history.push(p);
  }
  public void after_contextNode(TraversalDict source, ContextNode dest) {
    history.pop();
  }
  public void before_traversals(TraversalDict source, TraversalRef_NList dest) {
    TraversalDict it = (TraversalDict) history.peek();
    TraversalRef_NList p = new TraversalRef_NList();
    it.set_traversals(p);
    history.push(p);
  }
  public void after_traversals(TraversalDict source, TraversalRef_NList dest) {
    history.pop();
  }
  public void before_node(ContextNode source, ClassName dest) {
    ContextNode it = (ContextNode) history.peek();
    ClassName p = new ClassName();
    it.set_node(p);
    history.push(p);
  }
  public void after_node(ContextNode source, ClassName dest) {
    history.pop();
  }
  public void before_traversal(TraversalRef source, Traversal dest) {
    TraversalRef it = (TraversalRef) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_traversal((Traversal) p);
    history.push(p);
  }
  public void after_traversal(TraversalRef source, Traversal dest) {
    history.pop();
  }
  public void before_name(Strategy source, TraversalName dest) {
    Strategy it = (Strategy) history.peek();
    TraversalName p = new TraversalName();
    it.set_name(p);
    history.push(p);
  }
  public void after_name(Strategy source, TraversalName dest) {
    history.pop();
  }
  public void before_stratexpression(Strategy source, StratExpression dest) {
    Strategy it = (Strategy) history.peek();
    StratExpression p = new StratExpression();
    it.set_stratexpression(p);
    history.push(p);
  }
  public void after_stratexpression(Strategy source, StratExpression dest) {
    history.pop();
  }
  public void before_stratexp(StratExpression source, String dest) {
    StratExpression it = (StratExpression) history.peek();
    it.set_stratexp(dest);
  }
  public void before_name(XPath source, TraversalName dest) {
    XPath it = (XPath) history.peek();
    TraversalName p = new TraversalName();
    it.set_name(p);
    history.push(p);
  }
  public void after_name(XPath source, TraversalName dest) {
    history.pop();
  }
  public void before_xpath(XPath source, XPathExpression dest) {
    XPath it = (XPath) history.peek();
    XPathExpression p = new XPathExpression();
    it.set_xpath(p);
    history.push(p);
  }
  public void after_xpath(XPath source, XPathExpression dest) {
    history.pop();
  }
  public void before_xpathexp(XPathExpression source, String dest) {
    XPathExpression it = (XPathExpression) history.peek();
    it.set_xpathexp(dest);
  }
  public void before_xpathexp(XPathDef source, XPathExp dest) {
    XPathDef it = (XPathDef) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_xpathexp((XPathExp) p);
    history.push(p);
  }
  public void after_xpathexp(XPathDef source, XPathExp dest) {
    history.pop();
  }
  public void before_pathDir(CompactXPath source, PathDir dest) {
    CompactXPath it = (CompactXPath) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_pathDir((PathDir) p);
    history.push(p);
  }
  public void after_pathDir(CompactXPath source, PathDir dest) {
    history.pop();
  }
  public void before_target(CompactXPath source, ClassName dest) {
    CompactXPath it = (CompactXPath) history.peek();
    ClassName p = new ClassName();
    it.set_target(p);
    history.push(p);
  }
  public void after_target(CompactXPath source, ClassName dest) {
    history.pop();
  }
  public void before_next(CompactXPath source, CompactXPath dest) {
    CompactXPath it = (CompactXPath) history.peek();
    CompactXPath p = new CompactXPath();
    it.set_next(p);
    history.push(p);
  }
  public void after_next(CompactXPath source, CompactXPath dest) {
    history.pop();
  }
  public void before_op(VerboseXPath source, Op dest) {
    VerboseXPath it = (VerboseXPath) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_op((Op) p);
    history.push(p);
  }
  public void after_op(VerboseXPath source, Op dest) {
    history.pop();
  }
  public void before_arg1(VerboseXPath source, XPathRef dest) {
    VerboseXPath it = (VerboseXPath) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_arg1((XPathRef) p);
    history.push(p);
  }
  public void after_arg1(VerboseXPath source, XPathRef dest) {
    history.pop();
  }
  public void before_arg2(VerboseXPath source, XPathRef dest) {
    VerboseXPath it = (VerboseXPath) history.peek();
    Class c = dest.getClass();
    Object p = null;
    try {
      p = c.newInstance();
    } catch(Exception e) {
      e.printStackTrace();
    }
    it.set_arg2((XPathRef) p);
    history.push(p);
  }
  public void after_arg2(VerboseXPath source, XPathRef dest) {
    history.pop();
  }
  public void before_compactxpath(CXPathExp source, CompactXPath dest) {
    CXPathExp it = (CXPathExp) history.peek();
    CompactXPath p = new CompactXPath();
    it.set_compactxpath(p);
    history.push(p);
  }
  public void after_compactxpath(CXPathExp source, CompactXPath dest) {
    history.pop();
  }
  public void before_name(Variable source, ClassName dest) {
    Variable it = (Variable) history.peek();
    ClassName p = new ClassName();
    it.set_name(p);
    history.push(p);
  }
  public void after_name(Variable source, ClassName dest) {
    history.pop();
  }
  public void before_verbosexpath(ComplexXPathRef source, VerboseXPath dest) {
    ComplexXPathRef it = (ComplexXPathRef) history.peek();
    VerboseXPath p = new VerboseXPath();
    it.set_verbosexpath(p);
    history.push(p);
  }
  public void after_verbosexpath(ComplexXPathRef source, VerboseXPath dest) {
    history.pop();
  }
  public void before_name(TraversalName source, Ident dest) {
    TraversalName it = (TraversalName) history.peek();
    it.set_name(dest);
  }
  public void before_name(ClassName source, Ident dest) {
    ClassName it = (ClassName) history.peek();
    it.set_name(dest);
  }
  public void before_indent(PrintVisitor source, int dest) {
    PrintVisitor it = (PrintVisitor) history.peek();
    it.set_indent(dest);
  }
  public void before_needSpace(PrintVisitor source, boolean dest) {
    PrintVisitor it = (PrintVisitor) history.peek();
    it.set_needSpace(dest);
  }
  public void before_is_equal(SubgraphVisitor source, boolean dest) {
    SubgraphVisitor it = (SubgraphVisitor) history.peek();
    it.set_is_equal(dest);
  }
  public void before_is_equal(EqualVisitor source, boolean dest) {
    EqualVisitor it = (EqualVisitor) history.peek();
    it.set_is_equal(dest);
  }
  public void before_indent(DisplayVisitor source, int dest) {
    DisplayVisitor it = (DisplayVisitor) history.peek();
    it.set_indent(dest);
  }
  public void before_indent(TraceVisitor source, int dest) {
    TraceVisitor it = (TraceVisitor) history.peek();
    it.set_indent(dest);
  }
  public void before_first(TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    TraversalRef_NList it = (TraversalRef_NList) history.peek();
    Nonempty_TraversalRef_NList p = new Nonempty_TraversalRef_NList();
    it.set_first(p);
    history.push(p);
  }
  public void after_first(TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    history.pop();
  }
  public void before_it(Nonempty_TraversalRef_NList source, TraversalRef dest) {
    Nonempty_TraversalRef_NList it = (Nonempty_TraversalRef_NList) history.peek();
    TraversalRef p = new TraversalRef();
    it.set_it(p);
    history.push(p);
  }
  public void after_it(Nonempty_TraversalRef_NList source, TraversalRef dest) {
    history.pop();
  }
  public void before_next(Nonempty_TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    Nonempty_TraversalRef_NList it = (Nonempty_TraversalRef_NList) history.peek();
    Nonempty_TraversalRef_NList p = new Nonempty_TraversalRef_NList();
    it.set_next(p);
    history.push(p);
  }
  public void after_next(Nonempty_TraversalRef_NList source, Nonempty_TraversalRef_NList dest) {
    history.pop();
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    Object copy = get_copy();
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
